//functions for interactions
void mousePressed(){
  for (int i = 0; i<10; i++) {
    if (mouseX>screenX(700*cos(-2*(i+1)*PI/10), 700*sin(2*(i+1)*PI/10),0)-40 && 
        mouseX<screenX(700*cos(-2*(i+1)*PI/10), 700*sin(2*(i+1)*PI/10),0)+40 &&
        mouseY>screenY(700*cos(-2*(i+1)*PI/10), 700*sin(2*(i+1)*PI/10),0)-40 && 
        mouseY<screenY(700*cos(-2*(i+1)*PI/10), 700*sin(2*(i+1)*PI/10),0)+40){
          subclasses[i] = !subclasses[i];
        }
    }
  for (int i = 0; i<15; i++) {
    if (mouseX>screenX(0,0,-200*i)-40 && 
        mouseX<screenX(0,0,-200*i)+40 &&
        mouseY>screenY(0,0,-200*i)-40 && 
        mouseY<screenY(0,0,-200*i)+40){
          monthly[i]=!monthly[i];
        }
    }
}

void keyPressed(){
  if(key == '1'){
    colorBar = loadImage(colorPath[0]);
  }
    if(key == '2'){
    colorBar = loadImage(colorPath[1]);
  }
    if(key == '3'){
    colorBar = loadImage(colorPath[2]);
  }
}

void polygen_subclass(float[][] data, float[][] sum_matrix,boolean subclass_label){
  minValue1 = 900000;
  maxValue1 = -10000;
  minValue2 = 900000;
  maxValue2 = -10000;
  for (int i = 0; i<10;i++){
    if (sum_matrix[15][i]<minValue1){
      minValue1 = sum_matrix[15][i];
    }
    if (sum_matrix[15][i]>maxValue1){
      maxValue1 = sum_matrix[15][i];
    }
  }
  for (int i = 0; i<15;i++){
    if (sum_matrix[i][10]<minValue2){
      minValue2 = sum_matrix[i][10];
    }
    if (sum_matrix[i][10]>maxValue2){
      maxValue2 = sum_matrix[i][10];
    }
  }

      
  if (subclass_label){
    for (int j = 0;j<10;j++){
      int xInImage = int(map(sum_matrix[15][j],minValue1-200, maxValue1+200,0,colorBar.width));
      color c = colorBar.get(xInImage, colorBar.height/2);
      strokeWeight(1);
      stroke(c,transp);
    beginShape();
    for (int i = 0; i<14; i ++){
       line(map(data[i][j],0,100,0,300)*cos(-2*(j+1)*PI/10),map(data[i][j],0,100,0,300)*sin(2*(j+1)*PI/10),-200*i,map(data[i+1][j],0,100,0,300)*cos(-2*(j+1)*PI/10), map(data[i+1][j],0,100,0,300)*sin(2*(j+1)*PI/10),-200*(i+1));
    }
    endShape();
    }
    for (int i=0;i<14;i++){
      int xInImage2 = int(map(sum_matrix[i][10],minValue2-200, maxValue2+200,0,colorBar.width));
      int c2 = colorBar.get(xInImage2, colorBar.height/2);
      stroke(c2,transp+50);
      strokeWeight(1);
      pushMatrix();
      translate(0,0,-200*i);
      for (int j=0;j<10;j++){
      line(0, 0, map(data[i][j],0,100,0,300)*cos(-2*(j+1)*PI/10),map(data[i][j],0,100,0,300)*sin(2*(j+1)*PI/10));
    }
      popMatrix();
    }
  }
      
    
  for (int i = 0; i<15; i++) {
    pushMatrix();
    int xInImage = int(map(sum_matrix[i][10],minValue2-200, maxValue2+200,0,colorBar.width));
    color c = colorBar.get(xInImage, colorBar.height/2);
    fill(c,transp);
    noStroke();
    translate(0, 0,-i*200);
    beginShape();
    for(int j = 0; j <10; j++){
      vertex(map(data[i][j],0,100,0,300)*cos(-2*(j+1)*PI/10), map(data[i][j],0,100,0,300)*sin(2*(j+1)*PI/10));
    }
    if (subclass_label){
      endShape(CLOSE);
    }    
    popMatrix();
  }
}

void polygen_monthly(float[][] data, float[][] sum_matrix, int year_index, boolean monthly_label){
  if (monthly_label){
    minValue1 = 200000;
    maxValue1 = -200000;
    for (int i = 12*year_index; i<12*year_index+12; i=i+1){
    if (sum_matrix[i][10]<minValue1){
      minValue1 = sum_matrix[i][10];
    }
    if (sum_matrix[i][10]>maxValue1){
      maxValue1 = sum_matrix[i][10];
    }
  }
  for (int i = 12*year_index; i<12*year_index+12; i=i+1) {
    
    noStroke();
    int xInImage = int(map(sum_matrix[i][10],minValue1-200,maxValue1+200,0,colorBar.width));
    color c = colorBar.get(xInImage, colorBar.height/2);
    fill(c,150);
    pushMatrix();
    translate(0, 0,-year_index*200-(i-12*year_index-5)*16);
    beginShape();
    for(int j = 0; j <10; j++){
         vertex(map(data[i][j],0,100,0,600)*cos(-2*(j+1)*PI/10), map(data[i][j],0,100,0,600)*sin(2*(j+1)*PI/10));
    }
    endShape(CLOSE);
    popMatrix();
  }   
    fill(100);
    textSize(26);
    textAlign(CENTER);
    pushMatrix();
    translate(0, 0,-year_index*200-(12*year_index-12*year_index-5)*16);
    text("Jan.", 400*cos(-2*2*PI/10), 400*sin(2*2*PI/10));
    rotate(PI/2);
    popMatrix();
    pushMatrix();
    translate(0, 0,-year_index*200-(12*year_index+1-12*year_index-5)*16);
    text("Feb.", 400*cos(-2*2*PI/10), 400*sin(2*2*PI/10));
    rotate(PI/2);
    popMatrix();
    pushMatrix();
    translate(0, 0,-year_index*200-(12*year_index+2-12*year_index-5)*16);
    text("March", 400*cos(-2*2*PI/10), 400*sin(2*2*PI/10));
    popMatrix();
    pushMatrix();
    translate(0, 0,-year_index*200-(12*year_index+3-12*year_index-5)*16);
    text("April", 400*cos(-2*2*PI/10), 400*sin(2*2*PI/10));
    popMatrix();
    pushMatrix();
    translate(0, 0,-year_index*200-(12*year_index+4-12*year_index-5)*16);
    text("May", 400*cos(-2*2*PI/10), 400*sin(2*2*PI/10));
    popMatrix();
    pushMatrix();
    translate(0, 0,-year_index*200-(12*year_index+5-12*year_index-5)*16);
    text("June", 400*cos(-2*2*PI/10), 400*sin(2*2*PI/10));
    popMatrix();
    pushMatrix();
    translate(0, 0,-year_index*200-(12*year_index+6-12*year_index-5)*16);
    text("July", 400*cos(-2*2*PI/10), 400*sin(2*2*PI/10));
    popMatrix();
    pushMatrix();
    translate(0, 0,-year_index*200-(12*year_index+7-12*year_index-5)*16);
    text("Aug.", 400*cos(-2*2*PI/10), 400*sin(2*2*PI/10));
    popMatrix();
    pushMatrix();
    translate(0, 0,-year_index*200-(12*year_index+8-12*year_index-5)*16);
    text("Sept.", 400*cos(-2*2*PI/10), 400*sin(2*2*PI/10));
    popMatrix();
    pushMatrix();
    translate(0, 0,-year_index*200-(12*year_index+9-12*year_index-5)*16);
    text("Oct.", 400*cos(-2*2*PI/10), 400*sin(2*2*PI/10));
    popMatrix();
    pushMatrix();
    translate(0, 0,-year_index*200-(12*year_index+10-12*year_index-5)*16);
    text("Nov.", 400*cos(-2*2*PI/10), 400*sin(2*2*PI/10));
    popMatrix();    
    pushMatrix();
    translate(0, 0,-year_index*200-(12*year_index+11-12*year_index-5)*16);
    text("Dec.", 400*cos(-2*2*PI/10), 400*sin(2*2*PI/10)); 
    popMatrix();
  }
}
