void load_data(){
  deweyclassdata = loadTable("dewey_duration.csv","header");
  deweysumdata = loadTable("dewey_sum.csv","header");
  deweyclassdata_000 = loadTable("dewey_000.csv","header");
  deweysumdata_000 = loadTable("dewey_000_sum.csv","header");
  deweyclassdata_100 = loadTable("dewey_100.csv","header");
  deweysumdata_100 = loadTable("dewey_100_sum.csv","header");
  deweyclassdata_200 = loadTable("dewey_200.csv","header");
  deweysumdata_200 = loadTable("dewey_200_sum.csv","header");
  deweyclassdata_300 = loadTable("dewey_300.csv","header");
  deweysumdata_300 = loadTable("dewey_300_sum.csv","header");
  deweyclassdata_400 = loadTable("dewey_400.csv","header");
  deweysumdata_400 = loadTable("dewey_400_sum.csv","header");
  deweyclassdata_500 = loadTable("dewey_500.csv","header");
  deweysumdata_500 = loadTable("dewey_500_sum.csv","header");
  deweyclassdata_600 = loadTable("dewey_600.csv","header");
  deweysumdata_600 = loadTable("dewey_600_sum.csv","header");
  deweyclassdata_700 = loadTable("dewey_700.csv","header");
  deweysumdata_700 = loadTable("dewey_700_sum.csv","header");
  deweyclassdata_800 = loadTable("dewey_800.csv","header");
  deweysumdata_800 = loadTable("dewey_800_sum.csv","header");
  deweyclassdata_900 = loadTable("dewey_900.csv","header");
  deweysumdata_900 = loadTable("dewey_900_sum.csv","header");
  numRows = deweyclassdata.getRowCount();
  numColumns = deweyclassdata.getColumnCount();
  numRows_sub = deweyclassdata_000.getRowCount();
  numColumns_sub = deweyclassdata_000.getColumnCount();

  //dewey class
  duration_matrix = new float[numRows][numColumns];
  for (int i=0; i<numRows; i++) {
    for (int j=0; j<numColumns; j++) {
      duration_matrix[i][j] = deweyclassdata.getFloat(i, j);
    }
  }
  
  sum_matrix = new float[numRows+1][numColumns+1];
  for (int i=0; i<numRows+1; i++) {
    for (int j=0; j<numColumns+1; j++) {
      sum_matrix[i][j] = deweysumdata.getFloat(i, j);
    }
  }
  
  //subclass  
  duration_matrix_000 = new float[numRows][numColumns];
  for (int i=0; i<numRows_sub; i++) {
    for (int j=0; j<numColumns_sub; j++) {
      duration_matrix_000[i][j] = deweyclassdata_000.getFloat(i, j);
    }
  }
  
  sum_matrix_000 = new float[numRows+1][numColumns+1];
  for (int i=0; i<numRows_sub+1; i++) {
    for (int j=0; j<numColumns_sub+1; j++) {
      sum_matrix_000[i][j] = deweysumdata_000.getFloat(i, j);
    }
  }
  
  
  duration_matrix_100 = new float[numRows][numColumns];
  for (int i=0; i<numRows_sub; i++) {
    for (int j=0; j<numColumns_sub; j++) {
      duration_matrix_100[i][j] = deweyclassdata_100.getFloat(i, j);
    }
  }
  
  sum_matrix_100 = new float[numRows+1][numColumns+1];
  for (int i=0; i<numRows_sub+1; i++) {
    for (int j=0; j<numColumns_sub+1; j++) {
      sum_matrix_100[i][j] = deweysumdata_100.getFloat(i, j);
    }
  }
  
  
  duration_matrix_200 = new float[numRows][numColumns];
  for (int i=0; i<numRows_sub; i++) {
    for (int j=0; j<numColumns_sub; j++) {
      duration_matrix_200[i][j] = deweyclassdata_200.getFloat(i, j);
    }
  }
  
  sum_matrix_200 = new float[numRows+1][numColumns+1];
  for (int i=0; i<numRows_sub+1; i++) {
    for (int j=0; j<numColumns_sub+1; j++) {
      sum_matrix_200[i][j] = deweysumdata_200.getFloat(i, j);
    }
  }
  
  
  duration_matrix_300 = new float[numRows][numColumns];
  for (int i=0; i<numRows_sub; i++) {
    for (int j=0; j<numColumns_sub; j++) {
      duration_matrix_300[i][j] = deweyclassdata_300.getFloat(i, j);
    }
  }
  
  sum_matrix_300 = new float[numRows+1][numColumns+1];
  for (int i=0; i<numRows_sub+1; i++) {
    for (int j=0; j<numColumns_sub+1; j++) {
      sum_matrix_300[i][j] = deweysumdata_300.getFloat(i, j);
    }
  }
  
  
  duration_matrix_400 = new float[numRows][numColumns];
  for (int i=0; i<numRows_sub; i++) {
    for (int j=0; j<numColumns_sub; j++) {
      duration_matrix_400[i][j] = deweyclassdata_400.getFloat(i, j);
    }
  }
  
  sum_matrix_400 = new float[numRows+1][numColumns+1];
  for (int i=0; i<numRows_sub+1; i++) {
    for (int j=0; j<numColumns_sub+1; j++) {
      sum_matrix_400[i][j] = deweysumdata_400.getFloat(i, j);
    }
  }
  
  
  duration_matrix_500 = new float[numRows][numColumns];
  for (int i=0; i<numRows_sub; i++) {
    for (int j=0; j<numColumns_sub; j++) {
      duration_matrix_500[i][j] = deweyclassdata_500.getFloat(i, j);
    }
  }
  
  sum_matrix_500 = new float[numRows+1][numColumns+1];
  for (int i=0; i<numRows_sub+1; i++) {
    for (int j=0; j<numColumns_sub+1; j++) {
      sum_matrix_500[i][j] = deweysumdata_500.getFloat(i, j);
    }
  }
  
  
  duration_matrix_600 = new float[numRows][numColumns];
  for (int i=0; i<numRows_sub; i++) {
    for (int j=0; j<numColumns_sub; j++) {
      duration_matrix_600[i][j] = deweyclassdata_600.getFloat(i, j);
    }
  }
  
  sum_matrix_600 = new float[numRows+1][numColumns+1];
  for (int i=0; i<numRows_sub+1; i++) {
    for (int j=0; j<numColumns_sub+1; j++) {
      sum_matrix_600[i][j] = deweysumdata_600.getFloat(i, j);
    }
  }
  
  
  duration_matrix_700 = new float[numRows][numColumns];
  for (int i=0; i<numRows_sub; i++) {
    for (int j=0; j<numColumns_sub; j++) {
      duration_matrix_700[i][j] = deweyclassdata_700.getFloat(i, j);
    }
  }
  
  sum_matrix_700 = new float[numRows+1][numColumns+1];
  for (int i=0; i<numRows_sub+1; i++) {
    for (int j=0; j<numColumns_sub+1; j++) {
      sum_matrix_700[i][j] = deweysumdata_700.getFloat(i, j);
    }
  }
  
  
  duration_matrix_800 = new float[numRows][numColumns];
  for (int i=0; i<numRows_sub; i++) {
    for (int j=0; j<numColumns_sub; j++) {
      duration_matrix_800[i][j] = deweyclassdata_800.getFloat(i, j);
    }
  }
  
  sum_matrix_800 = new float[numRows+1][numColumns+1];
  for (int i=0; i<numRows_sub+1; i++) {
    for (int j=0; j<numColumns_sub+1; j++) {
      sum_matrix_800[i][j] = deweysumdata_800.getFloat(i, j);
    }
  }
  
  
  duration_matrix_900 = new float[numRows][numColumns];
  for (int i=0; i<numRows_sub; i++) {
    for (int j=0; j<numColumns_sub; j++) {
      duration_matrix_900[i][j] = deweyclassdata_900.getFloat(i, j);
    }
  }
  
  sum_matrix_900 = new float[numRows+1][numColumns+1];
  for (int i=0; i<numRows_sub+1; i++) {
    for (int j=0; j<numColumns_sub+1; j++) {
      sum_matrix_900[i][j] = deweysumdata_900.getFloat(i, j);
    }
  }
  
}
