import peasy.*;

import controlP5.*;

PeasyCam cam;

float bx;
float by;
float xOffset = 0.0; 
float yOffset = 0.0; 
boolean active;
boolean locked;
boolean overBox;
Table deweyclassdata;
Table deweysumdata;
Table deweyclassdata_000;
Table deweysumdata_000;
Table deweyclassdata_100;
Table deweysumdata_100;
Table deweyclassdata_200;
Table deweysumdata_200;
Table deweyclassdata_300;
Table deweysumdata_300;
Table deweyclassdata_400;
Table deweysumdata_400;
Table deweyclassdata_500;
Table deweysumdata_500;
Table deweyclassdata_600;
Table deweysumdata_600;
Table deweyclassdata_700;
Table deweysumdata_700;
Table deweyclassdata_800;
Table deweysumdata_800;
Table deweyclassdata_900;
Table deweysumdata_900;
int numRows, numColumns;
int numRows_sub, numColumns_sub;
float [][] duration_matrix; 
float [][] sum_matrix;
float [][] duration_matrix_000; 
float [][] sum_matrix_000;
float [][] duration_matrix_100; 
float [][] sum_matrix_100;
float [][] duration_matrix_200; 
float [][] sum_matrix_200;
float [][] duration_matrix_300; 
float [][] sum_matrix_300;
float [][] duration_matrix_400; 
float [][] sum_matrix_400;
float [][] duration_matrix_500; 
float [][] sum_matrix_500;
float [][] duration_matrix_600; 
float [][] sum_matrix_600;
float [][] duration_matrix_700; 
float [][] sum_matrix_700;
float [][] duration_matrix_800; 
float [][] sum_matrix_800;
float [][] duration_matrix_900; 
float [][] sum_matrix_900;
boolean []subclasses;
boolean []monthly;

float minValue1;
float maxValue1;
float minValue2;
float maxValue2;

float transp;

float duration_sum_value;
float sum_sum_value;
float sum_volume;
float duration_sum_value_2;
float sum_volume_2;

//color
PImage colorBar;
String[] colorPath={"gradient3.jpg","gradient1.jpg","gradient2.jpg"};

void setup() {
  size(1280, 760, P3D);
  smooth(4);
  textMode(SHAPE);
  cam = new PeasyCam(this, 0,0,0,4000);
  cam.setMinimumDistance(500);
  cam.setMaximumDistance(2500);  
  load_data();
  subclasses = new boolean[]{false, false, false, false, false, false, false,false, false, false};
  monthly = new boolean[]{false, false, false, false, false, false, false,false, false, false, false, false,false, false, false};
  colorBar = loadImage("gradient3.jpg");

}


void draw() { 
  background(255);
  cam.setActive(active); 
  active = true;
  fill(1);
  textSize(40);
  text("Checkout Duration and Popularity of Dewey Classes",0,-1200);
  textAlign(LEFT);
  text("Vertices to center length of polygon: checkout duration of each class or subclass.",-2300,1000);
  text("Color of polygon: the total number of checkouts in that year or month.",-2300,1100);
  text("Value of line plot: checkout duration of each class or subclass.",-2300,1200);
  text("Color of line plot: the total number of checkouts of each class or subclass.",-2300,1300);
  textSize(26);
  textAlign(CENTER);

//text
    fill(100);
    text("000", 800*cos(-2*1*PI/10), 800*sin(2*1*PI/10),50);
    text("100", 800*cos(-2*2*PI/10), 800*sin(2*2*PI/10),50);
    text("200", 800*cos(-2*3*PI/10), 800*sin(2*3*PI/10),50);
    text("300", 800*cos(-2*4*PI/10), 800*sin(2*4*PI/10),50);
    text("400", 800*cos(-2*5*PI/10), 800*sin(2*5*PI/10),50);
    text("500", 800*cos(-2*6*PI/10), 800*sin(2*6*PI/10),50);
    text("600", 800*cos(-2*7*PI/10), 800*sin(2*7*PI/10),50);
    text("700", 800*cos(-2*8*PI/10), 800*sin(2*8*PI/10),50);
    text("800", 800*cos(-2*9*PI/10), 800*sin(2*9*PI/10),50);
    text("900", 800*cos(-2*10*PI/10), 800*sin(2*10*PI/10),50);
   
    pushMatrix();
    fill(100);
    translate(0,0,0);
    text("2006", 300*cos(-2*5*PI/10), 300*sin(2*5*PI/10));
    translate(0,0,-200*1);
    text("2007", 300*cos(-2*5*PI/10), 300*sin(2*5*PI/10));
    translate(0,0,-200*1);
    text("2008", 300*cos(-2*5*PI/10), 300*sin(2*5*PI/10));
    translate(0,0,-200*1);
    text("2009", 300*cos(-2*5*PI/10), 300*sin(2*5*PI/10));
    translate(0,0,-200*1);
    text("2010", 300*cos(-2*5*PI/10), 300*sin(2*5*PI/10));
    translate(0,0,-200*1);
    text("2011", 300*cos(-2*5*PI/10), 300*sin(2*5*PI/10));
    translate(0,0,-200*1);
    text("2012", 300*cos(-2*5*PI/10), 300*sin(2*5*PI/10));
    translate(0,0,-200*1);
    text("2013", 300*cos(-2*5*PI/10), 300*sin(2*5*PI/10));
    translate(0,0,-200*1);
    text("2014", 300*cos(-2*5*PI/10), 300*sin(2*5*PI/10));
    translate(0,0,-200*1);
    text("2015", 300*cos(-2*5*PI/10), 300*sin(2*5*PI/10));
    translate(0,0,-200*1);
    text("2016", 300*cos(-2*5*PI/10), 300*sin(2*5*PI/10));
    translate(0,0,-200*1);
    text("2017", 300*cos(-2*5*PI/10), 300*sin(2*5*PI/10));
    translate(0,0,-200*1);
    text("2018", 300*cos(-2*5*PI/10), 300*sin(2*5*PI/10));
    translate(0,0,-200*1);
    text("2019", 300*cos(-2*5*PI/10), 300*sin(2*5*PI/10));
    translate(0,0,-200*1);
    text("2020", 300*cos(-2*5*PI/10), 300*sin(2*5*PI/10));
    popMatrix();

//z axis line 
  pushMatrix();
  fill(0,122);
  stroke(0);
  line(0,0,0,0,0,-2800);
  
  popMatrix();
  
//class polygen
//yearly information
if(monthly[0]||monthly[1]||monthly[2]||monthly[3]||monthly[4]||monthly[5]||monthly[6]||monthly[7]||monthly[8]||monthly[9]||monthly[10]||monthly[11]||monthly[12]||monthly[13]||monthly[14]==true){
  transp=20;
} else {transp = 150;}
  for (int i = 0; i<180; i=i+12) {
    pushMatrix();
    noStroke();
    sum_sum_value=sum_matrix[i][10]+sum_matrix[i+1][10]+sum_matrix[i+2][10]+sum_matrix[i+3][10]+sum_matrix[i+4][10]+sum_matrix[i+5][10]+sum_matrix[i+6][10]+sum_matrix[i+7][10]+sum_matrix[i+8][10]+sum_matrix[i+9][10]+sum_matrix[i+10][10]+sum_matrix[i+11][10];
    int xInImage = int(map(sum_sum_value,400000,2700000,0,colorBar.width));
  color c = colorBar.get(xInImage, colorBar.height/2);
  fill(c,transp);
    translate(0, 0,-i/12*200);
    beginShape();
    for(int j = 0; j <10; j++){
      sum_volume=sum_matrix[i][j]+sum_matrix[i+1][j]+sum_matrix[i+2][j]+sum_matrix[i+3][j]+sum_matrix[i+4][j]+sum_matrix[i+5][j]+sum_matrix[i+6][j]+sum_matrix[i+7][j]+sum_matrix[i+8][j]+sum_matrix[i+9][j]+sum_matrix[i+10][j]+sum_matrix[i+11][j];
      duration_sum_value=(duration_matrix[i][j]*sum_matrix[i][j]+duration_matrix[i+1][j]*sum_matrix[i+1][j]+duration_matrix[i+2][j]*sum_matrix[i+2][j]+duration_matrix[i+3][j]*sum_matrix[i+3][j]+duration_matrix[i+4][j]*sum_matrix[i+4][j]+duration_matrix[i+5][j]*sum_matrix[i+5][j]+duration_matrix[i+6][j]*sum_matrix[i+6][j]+duration_matrix[i+7][j]*sum_matrix[i+7][j]+duration_matrix[i+8][j]*sum_matrix[i+8][j]+duration_matrix[i+9][j]*sum_matrix[i+9][j]+duration_matrix[i+10][j]*sum_matrix[i+10][j]+duration_matrix[i+11][j]*sum_matrix[i+11][j])/sum_volume;
      vertex(map(duration_sum_value,0,100,0,600)*cos(-2*(j+1)*PI/10), map(duration_sum_value,0,100,0,600)*sin(2*(j+1)*PI/10));
    }
    endShape(CLOSE);      
    popMatrix();
  }
  pushMatrix();
  sum_sum_value=sum_matrix[0][10]+sum_matrix[1][10]+sum_matrix[2][10]+sum_matrix[3][10]+sum_matrix[4][10]+sum_matrix[5][10]+sum_matrix[6][10]+sum_matrix[7][10]+sum_matrix[8][10]+sum_matrix[9][10]+sum_matrix[10][10]+sum_matrix[11][10];
  int xInImage2 = int(map(sum_sum_value,400000,2700000,0,colorBar.width));
  color c2 = colorBar.get(xInImage2, colorBar.height/2);
    for (int i = 1; i<=10; i++) {
    stroke(c2,transp+50);
    strokeWeight(1);
    line(0, 0, 700*cos(-2*i*PI/10), 700*sin(2*i*PI/10));
  }
  popMatrix();
   for (int i = 12; i<180; i=i+12) {
      sum_sum_value=sum_matrix[i][10]+sum_matrix[i+1][10]+sum_matrix[i+2][10]+sum_matrix[i+3][10]+sum_matrix[i+4][10]+sum_matrix[i+5][10]+sum_matrix[i+6][10]+sum_matrix[i+7][10]+sum_matrix[i+8][10]+sum_matrix[i+9][10]+sum_matrix[i+10][10]+sum_matrix[i+11][10];
      int xInImage = int(map(sum_sum_value,400000,2700000,0,colorBar.width));
      int c = colorBar.get(xInImage, colorBar.height/2);
      stroke(c,transp+50);
      strokeWeight(1);
      pushMatrix();
      translate(0,0,-200*i/12);
      for(int j = 0; j <10; j++){
      sum_volume=sum_matrix[i][j]+sum_matrix[i+1][j]+sum_matrix[i+2][j]+sum_matrix[i+3][j]+sum_matrix[i+4][j]+sum_matrix[i+5][j]+sum_matrix[i+6][j]+sum_matrix[i+7][j]+sum_matrix[i+8][j]+sum_matrix[i+9][j]+sum_matrix[i+10][j]+sum_matrix[i+11][j];
      duration_sum_value=(duration_matrix[i][j]*sum_matrix[i][j]+duration_matrix[i+1][j]*sum_matrix[i+1][j]+duration_matrix[i+2][j]*sum_matrix[i+2][j]+duration_matrix[i+3][j]*sum_matrix[i+3][j]+duration_matrix[i+4][j]*sum_matrix[i+4][j]+duration_matrix[i+5][j]*sum_matrix[i+5][j]+duration_matrix[i+6][j]*sum_matrix[i+6][j]+duration_matrix[i+7][j]*sum_matrix[i+7][j]+duration_matrix[i+8][j]*sum_matrix[i+8][j]+duration_matrix[i+9][j]*sum_matrix[i+9][j]+duration_matrix[i+10][j]*sum_matrix[i+10][j]+duration_matrix[i+11][j]*sum_matrix[i+11][j])/sum_volume;
      line(0, 0, map(duration_sum_value,0,100,0,600)*cos(-2*(j+1)*PI/10),map(duration_sum_value,0,100,0,600)*sin(2*(j+1)*PI/10));
    }

      popMatrix();
  }
  
//line plots
for (int j = 0;j<10;j++){

  int xInImage = int(map(sum_matrix[180][j],250000,7200000,0,colorBar.width));
  color c = colorBar.get(xInImage, colorBar.height/2);
  strokeWeight(1);
  stroke(c,transp);
    beginShape();
  for (int i = 0; i<168; i=i+12){
    sum_volume=sum_matrix[i][j]+sum_matrix[i+1][j]+sum_matrix[i+2][j]+sum_matrix[i+3][j]+sum_matrix[i+4][j]+sum_matrix[i+5][j]+sum_matrix[i+6][j]+sum_matrix[i+7][j]+sum_matrix[i+8][j]+sum_matrix[i+9][j]+sum_matrix[i+10][j]+sum_matrix[i+11][j];
      duration_sum_value=(duration_matrix[i][j]*sum_matrix[i][j]+duration_matrix[i+1][j]*sum_matrix[i+1][j]+duration_matrix[i+2][j]*sum_matrix[i+2][j]+duration_matrix[i+3][j]*sum_matrix[i+3][j]+duration_matrix[i+4][j]*sum_matrix[i+4][j]+duration_matrix[i+5][j]*sum_matrix[i+5][j]+duration_matrix[i+6][j]*sum_matrix[i+6][j]+duration_matrix[i+7][j]*sum_matrix[i+7][j]+duration_matrix[i+8][j]*sum_matrix[i+8][j]+duration_matrix[i+9][j]*sum_matrix[i+9][j]+duration_matrix[i+10][j]*sum_matrix[i+10][j]+duration_matrix[i+11][j]*sum_matrix[i+11][j])/sum_volume;
      sum_volume_2=sum_matrix[i+12][j]+sum_matrix[i+1+12][j]+sum_matrix[i+2+12][j]+sum_matrix[i+3+12][j]+sum_matrix[i+4+12][j]+sum_matrix[i+5+12][j]+sum_matrix[i+6+12][j]+sum_matrix[i+7+12][j]+sum_matrix[i+8+12][j]+sum_matrix[i+9+12][j]+sum_matrix[i+10+12][j]+sum_matrix[i+11+12][j];
      duration_sum_value_2=(duration_matrix[i+12][j]*sum_matrix[i+12][j]+duration_matrix[i+1+12][j]*sum_matrix[i+1+12][j]+duration_matrix[i+2+12][j]*sum_matrix[i+2+12][j]+duration_matrix[i+3+12][j]*sum_matrix[i+3+12][j]+duration_matrix[i+4+12][j]*sum_matrix[i+4+12][j]+duration_matrix[i+5+12][j]*sum_matrix[i+5+12][j]+duration_matrix[i+6+12][j]*sum_matrix[i+6+12][j]+duration_matrix[i+7+12][j]*sum_matrix[i+7+12][j]+duration_matrix[i+8+12][j]*sum_matrix[i+8+12][j]+duration_matrix[i+9+12][j]*sum_matrix[i+9+12][j]+duration_matrix[i+10+12][j]*sum_matrix[i+10+12][j]+duration_matrix[i+11+12][j]*sum_matrix[i+11+12][j])/sum_volume_2;
      line(map(duration_sum_value,0,100,0,600)*cos(-2*(j+1)*PI/10),map(duration_sum_value,0,100,0,600)*sin(2*(j+1)*PI/10),-200*i/12,map(duration_sum_value_2,0,100,0,600)*cos(-2*(j+1)*PI/10), map(duration_sum_value_2,0,100,0,600)*sin(2*(j+1)*PI/10),-200*i/12-200);
  }
  endShape();
}

  
//monthly information
for (int i = 0;i<15;i++){
polygen_monthly(duration_matrix, sum_matrix, i, monthly[i]);
}

//subclass
pushMatrix();
translate(700*cos(-2*(0+1)*PI/10), 700*sin(2*(0+1)*PI/10),0);
polygen_subclass(duration_matrix_000, sum_matrix_000, subclasses[0]);
popMatrix();

pushMatrix();
translate(700*cos(-2*(1+1)*PI/10), 700*sin(2*(1+1)*PI/10),0);
polygen_subclass(duration_matrix_100, sum_matrix_100, subclasses[1]);
popMatrix();

pushMatrix();
translate(700*cos(-2*(2+1)*PI/10), 700*sin(2*(2+1)*PI/10),0);
polygen_subclass(duration_matrix_200, sum_matrix_200, subclasses[2]);
popMatrix();

pushMatrix();
translate(700*cos(-2*(3+1)*PI/10), 700*sin(2*(3+1)*PI/10),0);
polygen_subclass(duration_matrix_300, sum_matrix_300, subclasses[3]);
popMatrix();

pushMatrix();
translate(700*cos(-2*(4+1)*PI/10), 700*sin(2*(4+1)*PI/10),0);
polygen_subclass(duration_matrix_400, sum_matrix_400, subclasses[4]);
popMatrix();

pushMatrix();
translate(700*cos(-2*(5+1)*PI/10), 700*sin(2*(5+1)*PI/10),0);
polygen_subclass(duration_matrix_500, sum_matrix_500, subclasses[5]);
popMatrix();

pushMatrix();
translate(700*cos(-2*(6+1)*PI/10), 700*sin(2*(6+1)*PI/10),0);
polygen_subclass(duration_matrix_600, sum_matrix_600, subclasses[6]);
popMatrix();

pushMatrix();
translate(700*cos(-2*(7+1)*PI/10), 700*sin(2*(7+1)*PI/10),0);
polygen_subclass(duration_matrix_700, sum_matrix_700, subclasses[7]);
popMatrix();

pushMatrix();
translate(700*cos(-2*(8+1)*PI/10), 700*sin(2*(8+1)*PI/10),0);
polygen_subclass(duration_matrix_800, sum_matrix_800, subclasses[8]);
popMatrix();

pushMatrix();
translate(700*cos(-2*(9+1)*PI/10), 700*sin(2*(9+1)*PI/10),0);
polygen_subclass(duration_matrix_900, sum_matrix_900, subclasses[9]);
popMatrix();



}
